package com.sundot.airport.web.controller.ledger;

import java.util.List;
import javax.servlet.http.HttpServletResponse;

import com.sundot.airport.common.annotation.Log;
import com.sundot.airport.common.core.controller.BaseController;
import com.sundot.airport.common.core.domain.AjaxResult;
import com.sundot.airport.common.core.page.TableDataInfo;
import com.sundot.airport.common.dto.LedgerCommonQueryReqVO;
import com.sundot.airport.common.dto.LedgerCommonResVO;
import com.sundot.airport.common.enums.BusinessType;
import com.sundot.airport.common.utils.poi.ExcelUtil;
import com.sundot.airport.ledger.domain.LedgerRealtimeInterception;
import com.sundot.airport.ledger.service.ILedgerRealtimeInterceptionService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

/**
 * 部门实时质控拦截记录Controller
 */
@RestController
@RequestMapping("/ledger/realtimeInterception")
public class LedgerRealtimeInterceptionController extends BaseController {

    @Autowired
    private ILedgerRealtimeInterceptionService service;

    @PreAuthorize("@ss.hasPermi('ledger:realtimeInterception:list')")
    @GetMapping("/list")
    public TableDataInfo list(LedgerRealtimeInterception query) {
        startPage();
        List<LedgerRealtimeInterception> list = service.selectList(query);
        return getDataTable(list);
    }

    @PreAuthorize("@ss.hasPermi('ledger:realtimeInterception:export')")
    @Log(title = "部门实时质控拦截记录", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, LedgerRealtimeInterception query) {
        List<LedgerRealtimeInterception> list = service.selectList(query);
        ExcelUtil<LedgerRealtimeInterception> util = new ExcelUtil<>(LedgerRealtimeInterception.class);
        util.exportExcel(response, list, "部门实时质控拦截记录");
    }

    @PreAuthorize("@ss.hasPermi('ledger:realtimeInterception:query')")
    @GetMapping("/{id}")
    public AjaxResult getInfo(@PathVariable Long id) {
        return AjaxResult.success(service.getById(id));
    }

    /**
     * 实时质控拦截物品分布
     *
     * @param queryReq 查询参数
     * @return AjaxResult
     */
    @PostMapping("/realtimeInterceptionItem")
    public AjaxResult supervisionProblemPosition(@RequestBody LedgerCommonQueryReqVO queryReq) {
        List<LedgerCommonResVO> result = service.realtimeInterceptionItem(queryReq);
        return AjaxResult.success(result);
    }
}
